function edit_load()
	state = "edit"
	block = "block"
	tool = "erase"
	currentlayer = 1
	selectedx = 1
	selectedy = 1
	offsetx = 150
	offsety = 150
	shifts = false
	perspective = "edit"
	editstate = "edit"
	selection = 1
	if enablemusic then
		playsound(music)
	end
end
function edit_update(dt)
	settingsselections = {"Name: " .. name, "Text: " .. text, "Time: " .. time, "Steps: " .. steps, "Warps: " .. warps, "Height: " .. height, "Width: " .. width, "Layers:" .. layers,"File Name: " .. filename}
	editorselections = {"Invert camera controls: " .. tostring(camerainvert), "Mouse controls: " .. tostring(mousecontrols), "Left moused: " .. tostring(leftmoused), "Background: " .. tostring(background), "Color: " .. tostring(colors),"Enable Music: ".. tostring(enablemusic), "File Name: " .. filename, "Load Level", "Save Level", "Quit Editor"}
	help = {"This is Ortho Edit v2.5 by Hatninja", "Arrow keys or Mouse - moves the cursor", "Wasd - moves the camera","Shift - Opens tool bar","Space or Mouse1 - Places selected block","Enter/Return or Mouse2 - Use the selected tool", "Plus/Minus - Changes layer","1 to 6 - Selects block or tool","","Thanks for downloading Ortho Edit v2.5!", "Press escape to exit this menu"}
	checkblockcount()
	checkcoins()
	if love.keyboard.isDown("lshift", "rshift") then
		shifts = true
	else
		shifts = false
	end
	if level.layers[currentlayer] == nil and currentlayer ~= 1 then
		currentlayer = currentlayer - 1
	end
	if shifts == true then
		if love.keyboard.isDown("w") then
			if camerainvert == true then
				offsety = offsety - 8
			else
				offsety = offsety + 8
			end
		end
		if love.keyboard.isDown("s") then
			if camerainvert == true then
				offsety = offsety + 8
			else
				offsety = offsety - 8
			end
		end
		if love.keyboard.isDown("a") then
			if camerainvert == true then
				offsetx = offsetx - 8
			else
				offsetx = offsetx + 8
			end
		end
		if love.keyboard.isDown("d") then
			if camerainvert == true then
				offsetx = offsetx + 8
			else
				offsetx = offsetx - 8
			end
		end
	else
		if love.keyboard.isDown("w") then
			if camerainvert == true then
				offsety = offsety - 3
			else
				offsety = offsety + 3
			end
		end
		if love.keyboard.isDown("s") then
			if camerainvert == true then
				offsety = offsety + 3
			else
				offsety = offsety - 3
			end
		end
		if love.keyboard.isDown("a") then
			if camerainvert == true then
				offsetx = offsetx - 3
			else
				offsetx = offsetx + 3
			end
		end
		if love.keyboard.isDown("d") then
			if camerainvert == true then
				offsetx = offsetx + 3
			else
				offsetx = offsetx - 3
			end
		end
	end
	if mousecontrols == true then
		if editstate == "edit" then
			if mousey-40 < selectedy*40+offsety then
				if selectedy ~= 1 then
					selectedy = selectedy - 1
				end
			end
			if mousey-40 > selectedy*40+offsety then
				if selectedy ~= height then
					selectedy = selectedy + 1
				end
			end
			if mousex-40 > selectedx*40+offsetx then
				if selectedx ~= width then
					selectedx = selectedx + 1
				end
			end
			if mousex-40 < selectedx*40-40+offsetx then
				if selectedx ~= 1 then
					selectedx = selectedx - 1
				end
			end
			if mousestate == "l" then
				if mousey > 600-50 or mousey < 50 or mousex > 800-50 or mousex < 50 then else
					if leftmoused == false then
						blockplace()
					else
						tooluse()
					end
				end
			end
			if mousestate == "r" then
				if leftmoused == false then
					tooluse()
				else
					blockplace()
				end
			end
		end
	end
end
function edit_keypressed(k,u)
	if editstate == "edit" then
		if mousecontrols == false then
			if k == "up" then
				if selectedy ~= 1 then
					selectedy = selectedy - 1
				end
			end
			if k == "down" then
				if selectedy ~= height then
					selectedy = selectedy + 1
				end
			end
			if k == "right" then
				if selectedx ~= width then
					selectedx = selectedx + 1
				end
			end
			if k == "left" then
				if selectedx ~= 1 then
					selectedx = selectedx - 1
				end
			end
		end
		if k == "1" then
			if shifts == false then
				block = "block"
			else
				tool = "brush"
				firstpointx = nil
				firstpointy = nil
			end
			playsound(proceed)
		end
		if k == "2" then
			if shifts == false then
				block = "redblock"
			else
				tool = "erase"
				firstpointx = nil
				firstpointy = nil
			end
			playsound(proceed)
		end
		if k == "3" then
			if shifts == false then
				block = "goalblock"
			else
				tool = "fill"
			end
			playsound(proceed)
		end
		if k == "4" then
			if shifts == false then
				block = "player"
			else
				tool = "replace"
				firstpointx = nil
				firstpointy = nil
			end
			playsound(proceed)
		end
		if k == "5" then
			if shifts == false then
				block = "coin"
			end
			playsound(proceed)
		end
		if k == "6" then
			if shifts == false then
				block = "air"
			end
			playsound(proceed)
		end
		if k == "-" then
			if currentlayer ~= 1 then
				currentlayer = currentlayer - 1
				playsound(back)
			end
		end
		if k == "=" then
			if currentlayer ~= layers then
				currentlayer = currentlayer + 1
				playsound(proceed)
			else
				playsound(back)
			end
		end
		if k == " " then
			blockplace()
		end
		if k == "return" then
			tooluse()
		end
		if k == "escape" then
			editstate = "settings"
		end
	elseif editstate == "settings" then
		if selection == 1 then
			if u > 31 and u < 127 then
				name = name .. string.char(u)
			end
			if k == "backspace" then
				name = string.sub(name, 1, -2)
			end
		elseif selection == 2 then
			if u > 31 and u < 127 then
				text = text .. string.char(u)
			end
			if k == "backspace" then
				text = string.sub(text, 1, -2)
			end
		elseif selection == #settingsselections then
			if u > 31 and u < 127 then
				filename = filename .. string.char(u)
			end
			if k == "backspace" then
				filename = string.sub(filename, 1, -2)
			end
		end
		if k == "up" then
			if selection ~= 1 then
				selection = selection - 1
			end
		end
		if k == "down" then
			if selection ~= #settingsselections then
				selection = selection + 1
			end
		end
		if k == "right" then
			if selection == 3 then
				time = time + 0.1
			elseif selection == 4 then
				steps = steps + 1
			elseif selection == 5 then
				warps = warps + 1
			elseif selection == 6 then
				addheight()
				height = height + 1
			elseif selection == 7 then
				addwidth()
				width = width + 1
			elseif selection == 8 then
				createlayer()
				layers = layers + 1
			end
		end
		if k == "left" then
			if selection == 3 then
				if time ~= 0.1 then
					time = time - 0.1
				end
			elseif selection == 4 then
				if steps ~=  1 then
					steps = steps - 1
				end
			elseif selection == 5 then
				if warps ~= 1 then
					warps = warps - 1
				end
			elseif selection == 6 then
				if height ~= 1 then
					removeheight()
					height = height - 1
				end
			elseif selection == 7 then
				if width ~= 1 then
					removewidth()
					width = width - 1
				end
			elseif selection == 8 then
				if layers ~= 1 then
					deletelayer()
					layers = layers - 1
				end
			end
		end
		if k == "escape" then
			editstate = "edit"
			playsound(back)
		end
	elseif editstate == "editorsettings" then
		if k == "return" or k == "left" or k == "right" then
			if selection == 1 then
				camerainvert = not camerainvert
				savesettings()
			elseif selection == 2 then
				mousecontrols = not mousecontrols
				savesettings()
			elseif selection == 3 then
				leftmoused = not leftmoused
				savesettings()
			elseif selection == 4 then
				background = not background
				savesettings()
			elseif selection == 5 then
				colors = not colors
				savesettings()
			elseif selection == 6 then
				if enablemusic then
					love.audio.stop(music)
					enablemusic = false
				else
					love.audio.play(music)
					enablemusic = true
				end
				savesettings()
			end
		end
		if selection == #editorselections-3 then
			if u > 31 and u < 127 then
				filename = filename .. string.char(u)
			end
			if k == "backspace" then
				filename = string.sub(filename, 1, -2)
			end
		end
		if k == "return" then
			if selection == #editorselections-2  then
				load()
			elseif selection == #editorselections-1 then
				save()
			elseif selection == #editorselections then
				love.event.push("quit")
			end
		end
		if k == "up" then
			if selection ~= 1 then
				selection = selection - 1
			end
		end
		if k == "down" then
			if selection ~= #editorselections then
				selection = selection + 1
			end
		end
		if k == "escape" then
			editstate = "edit"
			playsound(back)
		end
	elseif editstate == "help" then
		if k == "escape" then
			editstate = "edit"
			playsound(back)
		end
	end
end
function edit_draw()
	love.graphics.setColor(0,0,0,255)
	love.graphics.rectangle("fill", 40+offsetx, 40+offsety, width*40, height*40)
	for l  = 1, layers do
		for y = 1, height do
			for x = 1, width do
				if perspective == "edit" then
					if 40*x+offsetx < 800 and 40*x+offsetx+40 > 0 and 40*y+offsety < 600 and 40*y+offsety+40 > 0 then
						if level.layers[currentlayer - 1] ~= nil then
							if level.layers[currentlayer - 1].y[y][x] == 1 then
								love.graphics.setColor(100,100,100)
								love.graphics.draw(blockimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
							elseif level.layers[currentlayer - 1].y[y][x] == 2 then
								love.graphics.setColor(100,0,0)
								love.graphics.draw(blockimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
							elseif level.layers[currentlayer - 1].y[y][x] == 3 then
								love.graphics.setColor(0,100,0)
								love.graphics.draw(blockimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
							elseif level.layers[currentlayer - 1].y[y][x] == 4 then
								love.graphics.setColor(100,100,100)
								love.graphics.draw(robotimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
							elseif level.layers[currentlayer - 1].y[y][x] == 5 then
								love.graphics.setColor(100,100,100)
								love.graphics.draw(coinimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
							end
						end
						if level.layers[currentlayer] ~= nil then
							if level.layers[currentlayer].y[y][x] == 1 then
								love.graphics.setColor(235,235,235)
								love.graphics.draw(blockimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
							elseif level.layers[currentlayer].y[y][x] == 2 then
								love.graphics.setColor(255,0,0)
								love.graphics.draw(blockimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
							elseif level.layers[currentlayer].y[y][x] == 3 then
								love.graphics.setColor(0,255,0)
								love.graphics.draw(blockimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
							elseif level.layers[currentlayer].y[y][x] == 4 then
								love.graphics.setColor(255,255,255)
								love.graphics.draw(robotimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
							elseif level.layers[currentlayer].y[y][x] == 5 then
								love.graphics.setColor(255,255,255)
								love.graphics.draw(coinimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
							end
						end
					end
				elseif perspective == "top" then
					for l = 1, layers do
						for x = 1, width do
							for y = 1, height do
								if 40*x+offsetx < 800 and 40*x+offsetx+40 > 0 and 40*y+offsety < 600 and 40*y+offsety+40 > 0 then
									if level.layers[currentlayer] ~= nil then
										if level.layers[l].y[y][x] == 1 then
											love.graphics.setColor(235,235,235)
											love.graphics.draw(blockimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
										elseif level.layers[l].y[y][x] == 2 then
											love.graphics.setColor(255,0,0)
											love.graphics.draw(blockimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
										elseif level.layers[l].y[y][x] == 3 then
											love.graphics.setColor(0,255,0)
											love.graphics.draw(blockimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
										elseif level.layers[l].y[y][x] == 4 then
											love.graphics.setColor(255,255,255)
											love.graphics.draw(robotimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
										elseif level.layers[l].y[y][x] == 5 then
											love.graphics.setColor(255,255,255)
											love.graphics.draw(coinimg, 40*x+offsetx, 40*y+offsety,nil,1/scale,1/scale)
										end
									end
								end
							end
						end
					end
				elseif perspective == "left" then
					for l = 1, layers do
						for x = 1, width do
							for y = 1, height do
								if 40*x+offsetx < 800 and 40*x+offsetx+40 > 0 and 40*l+offsety < 600 and 40*l+offsety+40 > 0 then
									if level.layers[currentlayer] ~= nil then
										if level.layers[l].y[y][x] == 1 then
											love.graphics.setColor(235,235,235)
											love.graphics.draw(blockimg, 40*x+offsetx, 40*l+offsety,nil,1/scale,1/scale)
										elseif level.layers[l].y[y][x] == 2 then
											love.graphics.setColor(255,0,0)
											love.graphics.draw(blockimg, 40*x+offsetx, 40*l+offsety,nil,1/scale,1/scale)
										elseif level.layers[l].y[y][x] == 3 then
											love.graphics.setColor(0,255,0)
											love.graphics.draw(blockimg, 40*x+offsetx, 40*l+offsety,nil,1/scale,1/scale)
										elseif level.layers[l].y[y][x] == 4 then
											love.graphics.setColor(255,255,255)
											love.graphics.draw(robotimg, 40*x+offsetx, 40*l+offsety,nil,1/scale,1/scale)
										elseif level.layers[l].y[y][x] == 5 then
											love.graphics.setColor(255,255,255)
											love.graphics.draw(coinimg, 40*x+offsetx, 40*l+offsety,nil,1/scale,1/scale)
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
	love.graphics.setColor(colorr,colorg,colorb,255)
	love.graphics.rectangle("line", 40+offsetx-1, 40+offsety-1, width*40+2, height*40+2)
	love.graphics.rectangle("line", 40+offsetx-1, 40+offsety-1, width*40+2, height*40+2)
	love.graphics.rectangle("line", 40+offsetx-1, 40+offsety-1, width*40+2, height*40+2)
	if firstpointx ~= nil and firstpointy ~= nil then
		if firstpointx > selectedx or firstpointy > selectedy then
			love.graphics.setColor(255,0,0,200)
			if firstpointx > selectedx and firstpointy > selectedy then
				love.graphics.rectangle("fill", firstpointx*40+offsetx, firstpointy*40+offsety, selectedx*40-firstpointx*40, selectedy*40-firstpointy*40)
			elseif firstpointx < selectedx and firstpointy >= selectedy then
				love.graphics.rectangle("fill", firstpointx*40+offsetx, firstpointy*40+offsety, selectedx*40-firstpointx*40+40, selectedy*40-firstpointy*40)
			else
				love.graphics.rectangle("fill", firstpointx*40+offsetx, firstpointy*40+offsety, selectedx*40-firstpointx*40, selectedy*40-firstpointy*40+40)
			end
		else	
			love.graphics.setColor(0,255,255,100)
			love.graphics.rectangle("fill", firstpointx*40+offsetx, firstpointy*40+offsety, selectedx*40-firstpointx*40+40, selectedy*40-firstpointy*40+40)
		end
	end
	love.graphics.setColor(0,0,255,150)
	love.graphics.rectangle("fill", selectedx*40+offsetx, selectedy*40+offsety, 40, 40)
	love.graphics.setColor(0,0,0,255)
	love.graphics.rectangle("fill",0,0,800-170,15)
	love.graphics.rectangle("fill",0,0,800-170,15)
	love.graphics.rectangle("fill",800-170,0,200,42)
	love.graphics.setColor(colorr,colorg,colorb)
	love.graphics.rectangle("line",0,0,800-170,16)
	love.graphics.rectangle("line",800-170,0,200,42)
	love.graphics.rectangle("line",0,0,800-170,16)
	love.graphics.rectangle("line",800-170,0,200,42)
	love.graphics.rectangle("line",0,0,800-170,16)
	love.graphics.rectangle("line",800-170,0,200,42)
	--overlay
	love.graphics.setColor(colorr,colorg,colorb)
	love.graphics.draw(borderimg, 2, 56,nil,1/scale,1/scale)
	love.graphics.draw(borderimg, 2, 98,nil,1/scale,1/scale)
	love.graphics.draw(borderimg, 2, 140,nil,1/scale,1/scale)
	love.graphics.draw(borderimg, 2, 182,nil,1/scale,1/scale)
	love.graphics.draw(borderimg, 2, 600-110,nil,1/scale,1/scale)
	love.graphics.draw(borderimg, 2, 600-54,nil,1/scale,1/scale)
	if shifts == false then
		love.graphics.draw(borderimg, 2, 224,nil,1/scale,1/scale)
		love.graphics.draw(borderimg, 2, 266,nil,1/scale,1/scale)
	end
	love.graphics.setColor(255,255,255)
	love.graphics.print("x: " .. selectedx, selectedx*40+offsetx+43, selectedy*40+offsety+9)
	love.graphics.print("y: " .. selectedy, selectedx*40+offsetx+43, selectedy*40+offsety+21)
	love.graphics.print("Editing Layer " .. currentlayer, 0,0)
	love.graphics.draw(blockiconimg, 800-90, 0,nil,1/scale,1/scale)
	love.graphics.print("x " .. blocks, 800-53, 10)
	love.graphics.draw(coinimg, 800-165, 0,nil,1/scale,1/scale)
	love.graphics.print("x " .. coins, 800-137, 10)
	love.graphics.print(tool, 2, 532)
	love.graphics.print(block, 2, 600-12)
	if block == "block" then
		love.graphics.setColor(255,255,255)
		love.graphics.draw(blockiconimg, 2, 600-54,nil,1/scale,1/scale)
	elseif block == "redblock" then
		love.graphics.setColor(255,0,0)
		love.graphics.draw(blockiconimg, 2, 600-54,nil,1/scale,1/scale)
	elseif block == "goalblock" then
		love.graphics.setColor(0,255,0)
		love.graphics.draw(blockiconimg, 2, 600-54,nil,1/scale,1/scale)
	elseif block == "player" then
		love.graphics.setColor(255,255,255)
		love.graphics.draw(roboticonimg, 2, 600-54,nil,1/scale,1/scale)
	elseif block == "coin" then
		love.graphics.setColor(255,255,255)
		love.graphics.draw(coinimg, 2, 600-54,nil,1/scale,1/scale)
	end
	if tool == "brush" then
		love.graphics.setColor(255,255,255)
		love.graphics.draw(brushiconimg, 2, 600-110,nil,1/scale,1/scale)
	elseif tool == "erase" then
		love.graphics.setColor(255,255,255)
		love.graphics.draw(eraseiconimg, 2, 600-110,nil,1/scale,1/scale)
	elseif tool == "fill" then
		love.graphics.setColor(255,255,255)
		love.graphics.draw(filliconimg, 2, 600-110,nil,1/scale,1/scale)
	elseif tool == "replace" then
		love.graphics.setColor(255,255,255)
		love.graphics.draw(replaceiconimg, 2, 600-110,nil,1/scale,1/scale)
	end
		if level.layers[currentlayer - 1] ~= nil then
		love.graphics.setColor(255,255,255)
	else
		love.graphics.setColor(255,0,0)
	end
	love.graphics.print("-", 100,0)
	if level.layers[currentlayer + 1] ~= nil then
		love.graphics.setColor(255,255,255)
	else
		love.graphics.setColor(255,0,0)
	end
	love.graphics.print("+", 106,0)
	love.graphics.setColor(0,0,0)
	love.graphics.setColor(255,255,255)
	love.graphics.print("1", 43, 78)
	love.graphics.print("2", 43, 120)
	love.graphics.print("3", 43, 162)
	love.graphics.print("4", 43, 204)
	love.graphics.print("5", 43, 246)
	love.graphics.print("6", 43, 288)
	
	if mousestate == "l" and mousey < 11 and mousex >= 150 and mousex <= 230 then --hey! i can put whatever i want in edit_draw() --Wow, old me is such a bad programmer... i'll probably put this in mousepressed later.
		editstate = "editorsettings"
		selection = 1
		love.audio.play(proceed)
	elseif mousestate == "l" and mousey < 11 and mousex >= 250 and mousex <= 340 then
		editstate = "settings"
		selection = 1
		love.audio.play(proceed)
	elseif mousestate == "l" and mousey < 11 and mousex >= 350 and mousex <= 420 then
		editstate = "help"
		selection = 1
		love.audio.play(proceed)
	elseif mousestate == "l" and mousey > 56 and mousey < 98 and mousex <= 50 then
		if shifts == false then
			block = "block"
		else
			tool = "brush"
		end
		love.audio.play(proceed)
	elseif mousestate == "l" and mousey > 98 and mousey < 138 and mousex <= 50 then
		if shifts == false then
			block = "redblock"
		else
			tool = "erase"
		end
		love.audio.play(proceed)
	elseif mousestate == "l" and mousey > 140 and mousey < 180 and mousex <= 50 then
		if shifts == false then
			block = "goalblock"
		else
			tool = "fill"
		end
		love.audio.play(proceed)
	elseif mousestate == "l" and mousey > 182 and mousey < 222 and mousex <= 50 then
		if shifts == false then
			block = "player"
		else
			tool = "replace"
		end
		love.audio.play(proceed)
	elseif mousestate == "l" and mousey > 224 and mousey < 264 and mousex <= 50 then
		if shifts == false then
			block = "coin"
		else
		 	--nothing
		end
		love.audio.play(proceed)
	elseif mousestate == "l" and mousey > 266 and mousey < 306 and mousex <= 50 then
		if shifts == false then
			block = "air"
		else
			--nothing
		end
		love.audio.play(proceed)
	end
	if shifts == false then
		love.graphics.setColor(255,255,255)
		love.graphics.print("Blocks", 0, 42)
		love.graphics.draw(roboticonimg, 2, 182,nil,1/scale,1/scale)
		love.graphics.draw(coinimg, 2, 224,nil,1/scale,1/scale)
		love.graphics.draw(blockiconimg, 2, 56,nil,1/scale,1/scale)
		love.graphics.setColor(255,0,0)
		love.graphics.draw(blockiconimg, 2, 98,nil,1/scale,1/scale)
		love.graphics.setColor(0,255,0)
		love.graphics.draw(blockiconimg, 2, 140,nil,1/scale,1/scale)
	else
		love.graphics.setColor(255,255,255)
		love.graphics.print("Tools", 0, 42)
		love.graphics.draw(brushiconimg, 2, 56,nil,1/scale,1/scale)
		love.graphics.draw(eraseiconimg, 2, 98,nil,1/scale,1/scale)
		love.graphics.draw(filliconimg, 2, 140,nil,1/scale,1/scale)
		love.graphics.draw(replaceiconimg, 2, 182,nil,1/scale,1/scale)
	end
	if editstate == "editorsettings" then
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill", 150-4, 0, 330, 12*#editorselections+16)
		for i = 1, #editorselections do
			if selection == i then
				love.graphics.setColor(colorr,colorg,colorb)
				love.graphics.rectangle("line", 150-4, 0, 330, 12*#editorselections+16)
				love.graphics.rectangle("line", 150-4, 0, 330, 12*#editorselections+16)
				love.graphics.rectangle("line", 150-4, 0, 330, 12*#editorselections+16)
			else
				love.graphics.setColor(255,255,255)
			end
			love.graphics.print(editorselections[i], 0, 12*i,0,1,1,-150,0)
		end
	elseif editstate == "settings" then
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill", 250-4, 0, 330,12*#settingsselections+16)
		for i = 1, #settingsselections do
			if selection == i then
				love.graphics.setColor(colorr,colorg,colorb)
				love.graphics.rectangle("line", 250-4, 0, 330,12*#settingsselections+16)
				love.graphics.rectangle("line", 250-4, 0, 330,12*#settingsselections+16)
				love.graphics.rectangle("line", 250-4, 0, 330,12*#settingsselections+16)
			else
				love.graphics.setColor(255,255,255)
			end
			love.graphics.print(settingsselections[i], 0, 12*i,0,1,1,-250,0)
		end
	elseif editstate == "help" then
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill", 350-4, 0, 330, 12*#help+16)
		love.graphics.setColor(colorr,colorg,colorb)
		love.graphics.rectangle("line", 350-4, 0, 330, 12*#help+16)
		love.graphics.rectangle("line", 350-4, 0, 330, 12*#help+16)
		love.graphics.rectangle("line", 350-4, 0, 330, 12*#help+16)
		for i = 1, #help do
			love.graphics.setColor(255,255,255)
			love.graphics.print(help[i], 0, 12*i,0,1,1,-350,0)
		end
	end
	love.graphics.setColor(255,255,255)
	love.graphics.print("File/Options", 150,0)
	love.graphics.print("Level settings", 250,0)
	love.graphics.print("Help Me!", 350,0)
	love.graphics.print("Ortho Edit v2.5", 800-95,600-12)
end
function blockplace()
	if level.layers[currentlayer].y[selectedy][selectedx] ~= nil then
		if perspective == "edit" then
			if block == "block" then
				level.layers[currentlayer].y[selectedy][selectedx] = 1
			elseif block == "redblock" then
				level.layers[currentlayer].y[selectedy][selectedx] = 2
			elseif block == "goalblock" then
				level.layers[currentlayer].y[selectedy][selectedx] = 3
			elseif block == "player" then
				for l = 1, layers do
					for y = 1, height do
						for x = 1, width do
							if level.layers[l].y[y][x] == 4 then
								level.layers[l].y[y][x] = 0
							end
						end
					end
				end
				level.layers[currentlayer].y[selectedy][selectedx] = 4
				love.audio.play(winning)
			elseif block == "coin" then
				love.audio.play(coin)
				level.layers[currentlayer].y[selectedy][selectedx] = 5
			elseif block == "air" then
				level.layers[currentlayer].y[selectedy][selectedx] = 0
			end
		end
	end
end
function tooluse()
	if perspective == "edit" then
		if block == "block" then
			blockfilling = 1
		elseif block == "redblock" then
			blockfilling = 2
		elseif block == "goalblock" then
			blockfilling = 3
		elseif block == "player" then
			blockfilling = 4
		elseif block == "coin" then
			blockfilling = 5
		elseif block == "air" then
			blockfilling = 0
		end
		if tool == "brush" then
			level.layers[currentlayer].y[selectedy][selectedx] = blockfilling
		elseif tool == "erase" then
			level.layers[currentlayer].y[selectedy][selectedx] = 0
		elseif tool == "fill" then
			if firstpointx == nil then
				firstpointx = selectedx
				firstpointy = selectedy
			else
				for y = firstpointy, selectedy do
					for x = firstpointx, selectedx do
						level.layers[currentlayer].y[y][x] = blockfilling
						if x >= selectedx and y >= selectedy then
							firstpointx = nil
							firstpointy = nil
						end
					end
				end
			end
		elseif tool == "replace" then
			if level.layers[currentlayer].y[selectedy][selectedx] == 1 then
				blockinput = 1
			elseif level.layers[currentlayer].y[selectedy][selectedx] == 2 then
				blockinput = 2
			elseif level.layers[currentlayer].y[selectedy][selectedx] == 3 then
				blockinput = 3
			elseif level.layers[currentlayer].y[selectedy][selectedx] == 4 then
				blockinput = 4
			elseif level.layers[currentlayer].y[selectedy][selectedx] == 5 then
				blockinput = 5
			elseif level.layers[currentlayer].y[selectedy][selectedx] == 0 then
				blockinput = 0
			end
			for y = 1, height do
				for x = 1, width do
					if level.layers[currentlayer].y[y][x] == blockinput then
						level.layers[currentlayer].y[y][x] = blockfilling
					end
				end
			end
		end
	end
end