--Yeah, im done with this 1 year old code -Hatninja
require "edit"
function love.load()
	scale = 1
	love.graphics.setDefaultImageFilter("nearest", "nearest")
	love.graphics.setMode(800*scale,600*scale)
	love.filesystem.setIdentity("OrthoEdit")
	math.randomseed(os.time())
	if not love.filesystem.exists("Levels") then
		love.filesystem.mkdir("Levels")
	end
	windowheight = love.graphics.getHeight()
	windowwidth = love.graphics.getWidth()
	mousex, mousey = love.mouse.getPosition()
	height = 5
	width = 8
	time = 1.5
	steps = 0
	warps = 0
	layers = 2
	coins = 0
	blocks = 27
	text = "Hi!"
	name = "My Level Name"
	filename = "level"
	love.mouse.setVisible(false)
	
	if love.filesystem.exists("settings.txt") then
		loadsettings()
	else
		camerainvert = true
		mousecontrols = true
		invertwheel = false
		leftmoused = false
		mousecamera = false
		background = true
		colors = true
		enablemusic = true
		scale = 1
		savesettings()
	end
	
	if scale == 1 then
		cursor = love.graphics.newImage("sprites/cursor.png")	
		blockimg = love.graphics.newImage("sprites/block.png")
		robotimg = love.graphics.newImage("sprites/robot.png")
		coinimg = love.graphics.newImage("sprites/coin.png")
		blockiconimg = love.graphics.newImage("sprites/blockicon.png")
		roboticonimg = love.graphics.newImage("sprites/roboticon.png")
		brushiconimg = love.graphics.newImage("sprites/brushicon.png")
		eraseiconimg = love.graphics.newImage("sprites/eraseicon.png")
		filliconimg = love.graphics.newImage("sprites/fillicon.png")
		replaceiconimg = love.graphics.newImage("sprites/replaceicon.png")
		borderimg = love.graphics.newImage("sprites/blockborder.png")
	else
		cursor = love.graphics.newImage("bigsprites/cursor.png")	
		blockimg = love.graphics.newImage("bigsprites/block.png")
		robotimg = love.graphics.newImage("bigsprites/robot.png")
		coinimg = love.graphics.newImage("bigsprites/coin.png")
		blockiconimg = love.graphics.newImage("bigsprites/blockicon.png")
		roboticonimg = love.graphics.newImage("bigsprites/roboticon.png")
		brushiconimg = love.graphics.newImage("bigsprites/brushicon.png")
		eraseiconimg = love.graphics.newImage("bigsprites/eraseicon.png")
		filliconimg = love.graphics.newImage("bigsprites/fillicon.png")
		replaceiconimg = love.graphics.newImage("bigsprites/replaceicon.png")
		borderimg = love.graphics.newImage("bigsprites/blockborder.png")
	end
	
	scanlines = love.graphics.newImage("scanlines.png")
	icon = love.graphics.newImage("icon.png")
	scanlinesscroll = 0
	backgroundscroll1 = 0
	backgroundscroll2 = 0
	sm1img = love.graphics.newImage("backgroundscroll1.png")
	sm2img = love.graphics.newImage("backgroundscroll2.png")
	
	coin = love.audio.newSource("sound/coin.ogg","static")
	back = love.audio.newSource("sound/back.ogg","static")
	winning = love.audio.newSource("sound/winning.ogg","static")
	proceed = love.audio.newSource("sound/proceed.ogg","static")
	music = love.audio.newSource("sound/menu_back.ogg","stream");music:setLooping(true)
	
	mousestate = "nothing"
	love.graphics.setIcon(icon)
	
	currentcolor = math.random(1,6)
	colortimer = 0
	colorr = 150
	colorg = 150
	colorb = 150
	colortable = {}
	colortable[1] = {255,0,0}
	colortable[2] = {0,255,0}
	colortable[3] = {0,0,255}
	colortable[4] = {0,255,255}
	colortable[5] = {255,255,0}
	colortable[6] = {255,0,255}
	
	level = {}
	level.layers = {}
	level.layers[1] = {}
	level.layers[1].y = {}
	level.layers[1].y[1] = {0,0,0,0,0,0,0,0}
	level.layers[1].y[2] = {1,1,1,1,1,1,1,3}
	level.layers[1].y[3] = {1,1,1,1,1,1,1,3}
	level.layers[1].y[4] = {1,1,1,1,1,1,1,3}
	level.layers[1].y[5] = {0,0,0,0,0,0,0,0}
	level.layers[2] = {}
	level.layers[2].y = {}
	level.layers[2].y[1] = {0,0,0,0,0,5,0,0}
	level.layers[2].y[2] = {0,0,0,0,0,0,0,0}
	level.layers[2].y[3] = {4,0,0,0,0,0,0,0}
	level.layers[2].y[4] = {0,0,0,0,0,0,0,0}
	level.layers[2].y[5] = {0,5,0,0,0,0,0,0}
	
	edit_load()
end
function love.update(dt)
	mousex, mousey = love.mouse.getX()/scale, love.mouse.getY()/scale
	if _G[state.."_update"] then
		_G[state.."_update"](dt)
	end
	if colors == true then
		colortimer = colortimer + 1*dt
		if colortimer >= 1 then
			colortimer = 0
			currentcolor = math.random(1,6)
		end
		if colortable[currentcolor][1] == 255 then
			if colorr ~= 255 then
				colorr = colorr + 1
			end
		else
			if colorr ~= 0 then
				colorr = colorr - 1
			end
		end
		if colortable[currentcolor][2] == 255 then
			if colorg ~= 255 then
				colorg = colorg + 1
			end
		else
			if colorg ~= 0 then
				colorg = colorg - 1
			end
		end
		if colortable[currentcolor][3] == 255 then
			if colorb ~= 255 then
				colorb = colorb + 1
			end
		else
			if colorb ~= 0 then
				colorb = colorb - 1
			end
		end
	else
		colorr = 150
		colorg = 150
		colorb = 150
	end
	scanlinesscroll = scanlinesscroll + 20*dt
	backgroundscroll1 = backgroundscroll1 + 80*dt
	backgroundscroll2 = backgroundscroll2 + 60*dt
	if scanlinesscroll >= 600 then
		scanlinesscroll = 0
	end
	if backgroundscroll1 >= 600 then
		backgroundscroll1 = 0
	elseif backgroundscroll2 >= 800 then
		backgroundscroll2 = 0
	end
	love.graphics.setCaption("OrthoEdit "..love.timer.getFPS())
end
function love.keypressed(k, u)
	if _G[state.."_keypressed"] then
		_G[state.."_keypressed"](k, u)
	end
end
function love.draw()
	love.graphics.scale(scale,scale)
	if background == true then
		love.graphics.setColor(colorr,colorg,colorb,100)
		love.graphics.draw(sm1img,0,backgroundscroll1-600)	
		love.graphics.draw(sm1img,0,backgroundscroll1)
		love.graphics.draw(sm2img,backgroundscroll2-800,0)	
		love.graphics.draw(sm2img,backgroundscroll2,0)
	end
	love.graphics.setColor(255,255,255)
	love.graphics.draw(scanlines,0,scanlinesscroll-600)	
	love.graphics.draw(scanlines,0,scanlinesscroll)
	if _G[state.."_draw"] then
		_G[state.."_draw"]()
	end
	love.graphics.setColor(colorr,colorg,colorb)
	love.graphics.draw(cursor,mousex,mousey)
end
function split( _sInput, _sDelimiter )
	local tReturn = {}
	local delimiter = string.gsub( _sDelimiter, "([%^%$%(%)%%%.%[%]%*%+%-%?])", "%%%1" )
	local searchPattern = "([^"..delimiter.."]+)"..delimiter.."?"
	for match in string.gmatch( _sInput, searchPattern ) do
		table.insert( tReturn, match )
	end
	return tReturn
end
function playsound(source)
	love.audio.stop(source)
	love.audio.rewind(source)
	love.audio.play(source)
end
function save()
	love.audio.play(winning)
	if not love.filesystem.exists("Levels") then
		love.filesystem.mkdir("Levels")
	end
	checkcoins()
	local image = love.image.newImageData(width,height * layers)
	local thetable = {}
	local anumber = 0
	for y = 1, image:getHeight() do
		for x = 1, image:getWidth() do
			image:setPixel(x-1,y-1,255,255,255,255)
		end
	end
	for i = 0, layers-1 do
		if i ~= 0 then
			anumber = anumber + height
		end
		table.insert(thetable, 1, anumber)
	end
	for l = 1, layers do
		for y = 1, height do
			for x = 1, width do
				if level.layers[l].y[y][x] == 1 then
					image:setPixel(x-1,y-1+thetable[l],0,0,0,255)
				elseif level.layers[l].y[y][x] == 2 then
					image:setPixel(x-1,y-1+thetable[l],255,0,0,255)
				elseif level.layers[l].y[y][x] == 3 then
					image:setPixel(x-1,y-1+thetable[l],0,255,0,255)
				elseif level.layers[l].y[y][x] == 4 then
					image:setPixel(x-1,y-1+thetable[l],0,0,255,255)
				elseif level.layers[l].y[y][x] == 5 then	
					image:setPixel(x-1,y-1+thetable[l],255,255,0,255)
				end
			end
		end
	end
	image:encode(filename..".png", "png")
	local imagedata = love.filesystem.read(filename..".png")
	love.filesystem.write("Levels/"..filename..".png", imagedata)
	love.filesystem.remove(filename..".png")
	local config = love.filesystem.newFile("Levels/"..filename..".txt")
	local open = config:open("w")
	config:write("height="..layers.."\n")
	config:write("name="..name.."\n")
	if text ~= "" then
		config:write("text="..text.."!\n")
	end
	config:write("time="..time.."!\n")
	config:write("steps="..steps.."\n")
	config:write("warps="..warps.."\n")
	config:write("coins="..coins.."\n")
	
	openSaveFolder("levels")
end
function load()
	love.audio.play(winning)
	if not love.filesystem.exists("Levels/"..filename.."/"..filename..".png") then
		openSaveFolder("levels")
	else
		local imagedata = love.image.newImageData("Levels/"..filename.."/"..filename..".png")
		local thetable = {}
		local anumber = 0
		local thefile = {}
		for line in love.filesystem.lines("Levels/"..filename.."/"..filename..".txt") do
			table.insert(thefile, line)
		end
		for i = 1, #thefile do
			local lol = split(thefile[i], "=")
			if lol[1] == "height" then
				layers = tonumber(lol[2])
				height = imagedata:getHeight() / layers
			elseif lol[1] == "name" then
				name = lol[2]
			elseif lol[1] == "text" then
				text = lol[2]
			elseif lol[1] == "time" then
				time = tonumber(lol[2])
			elseif lol[1] == "steps" then
				steps = tonumber(lol[2])
			elseif lol[1] == "warps" then
				warps = tonumber(lol[2])
			elseif lol[1] == "coins" then
				coins = tonumber(lol[2])
			end
		end
		for i = 0, layers-1 do
			if i ~= 0 then
				anumber = anumber + height
			end
			table.insert(thetable, 1, anumber)
		end
		for l = 1, layers do
			for y = 1, height do
				for x = 1, imagedata:getWidth() do
					local r,g,b,a = imagedata:getPixel(x-1, y-1+thetable[l])
					if r == 0 and g == 0 and b == 0 then
						level.layers[l].y[y][x] = 1
					elseif r == 255 and g == 0 and b == 0 then
						level.layers[l].y[y][x] = 2
					elseif r == 0 and g == 255 and b == 0 then
						level.layers[l].y[y][x] = 3
					elseif r == 0 and g == 0 and b == 255 then
						level.layers[l].y[y][x] = 4
					elseif r == 255 and g == 255 and b == 0 then
						level.layers[l].y[y][x] = 5
					elseif r == 255 and g == 255 and b == 255 then
						level.layers[l].y[y][x] = 0
					end
				end
			end
		end
	end
end
function loadsettings()
	local chunk = love.filesystem.read("settings.txt")
	local chunk2 = split(chunk, ";")
	if chunk2[1] == "true" then --This is the result of a custom toboolean() not working for some odd reason -.-
		camerainvert = true
	else
		camerainvert = false
	end
	if chunk2[2] == "true" then
		mousecontrols = true
	else
		mousecontrols = false
	end
	if chunk2[3] == "true" then
		leftmoused = true
	else
		leftmoused = false
	end
	if chunk2[4] == "true" then
		background = true
	else
		background = false
	end
	if chunk2[5] == "true" then
		colors = true
	else
		colors = false
	end
	if chunk2[6] == "true" then
		enablemusic = true
	else
		enablemusic = false
	end
	scale = tonumber(chunk2[7])
end
function savesettings()
	love.filesystem.write("settings.txt", tostring(camerainvert)..";"..tostring(mousecontrols)..";"..tostring(leftmoused)..";"..tostring(background)..";"..tostring(colors)..";"..tostring(enablemusic)..";"..scale)
end
function createlayer()
	local layertable = {}
	level.layers[layers + 1] = {}
	level.layers[layers + 1].y = {}
	local thestring = "0"
	for i = 1, width do
		if width ~= 1 then
			thestring = thestring..",0"
		end
	end
	for i = 1, layers do
		for ii = 1, height do
			level.layers[layers + 1].y[ii] = split(thestring, ",")
			for iii = 1, width do
				level.layers[i].y[ii][iii] = tonumber(level.layers[i].y[ii][iii])
			end
		end
	end
end
function addwidth()
	for i = 1, layers do
		for o = 1, height do
			table.insert(level.layers[i].y[o], #level.layers[i].y[o]+1, 0)
		end
	end	
end
function addheight()
	local thestring = "0"
	for i = 1, width do
		if width ~= 1 then
			thestring = thestring..",0"
		end
	end
	for i = 1, layers do
		level.layers[i].y[height + 1] = split(thestring, ",")
		for ii = 1, height do
			for iii = 1, width do
				level.layers[i].y[ii][iii] = tonumber(level.layers[i].y[ii][iii])
			end
		end
	end
end
function deletelayer()
	level.layers[layers] = nil
end
function removewidth()
	for i = 1, layers do
		for o = 1, height do
			table.remove(level.layers[i].y[o], #level.layers[i].y[o])
		end
	end
end
function removeheight()
	for i = 1, layers do
		level.layers[i].y[height] = nil
	end
end
function openSaveFolder(subfolder) --By Slime
	local path = love.filesystem.getSaveDirectory()
	path = subfolder and path.."/"..subfolder or path
	local cmdstr
	local successval = 0
	if os.getenv("WINDIR") then -- lolwindows
		--cmdstr = "Explorer /root,%s"
		if path:match("LOVE") then --hardcoded to fix ISO characters in usernames and made sure release mode doesn't mess anything up -saso
			cmdstr = "Explorer %%appdata%%\\LOVE\\OrthoEdit"
		else
			cmdstr = "Explorer %%appdata%%\\OrthoEdit"
		end
		path = path:gsub("/", "\\")
		successval = 1
	elseif os.getenv("HOME") then
		if path:match("/Library/Application Support") then -- OSX
			cmdstr = "open \"%s\""
		else -- linux?
			cmdstr = "xdg-open \"%s\""
		end
	end
	-- returns true if successfully opened folder
	return cmdstr and os.execute(cmdstr:format(path)) == successval
end
function reset()
	height = 5
	width = 8
	time = 1.5
	steps = 0
	warps = 0
	layers = 2
	coins = 0
	text = "This is my custom level"
	name = "My Level"
	filename = "level"
	level = {}
	level.layers = {}
	level.layers[1] = {}
	level.layers[1].y = {}
	level.layers[1].y[1] = {0,0,0,0,0,0,0,0}
	level.layers[1].y[2] = {1,1,1,1,1,1,1,3}
	level.layers[1].y[3] = {1,1,1,1,1,1,1,3}
	level.layers[1].y[4] = {1,1,1,1,1,1,1,3}
	level.layers[1].y[5] = {0,0,0,0,0,0,0,0}
	level.layers[2] = {}
	level.layers[2].y = {}
	level.layers[2].y[1] = {0,0,0,0,0,5,0,0}
	level.layers[2].y[2] = {0,0,0,0,0,0,0,0}
	level.layers[2].y[3] = {4,0,0,0,0,0,0,0}
	level.layers[2].y[4] = {0,0,0,0,0,0,0,0}
	level.layers[2].y[5] = {0,5,0,0,0,0,0,0}
end
function checkcoins()
	coins = 0
	for l = 1, layers do
		for x = 1, width do
			for y = 1, height do
				if level.layers[l].y[y][x] == 5 then
					coins = coins + 1
				end
			end
		end
	end
end
function checkblockcount()
	blocks = 0
	for l = 1, layers do
		for x = 1, width do
			for y = 1, height do
				if level.layers[l].y[y][x] ~= 0 and level.layers[l].y[y][x] ~= 4 and level.layers[l].y[y][x] ~= 5 then
					blocks = blocks + 1
				end
			end
		end
	end
end
function love.mousepressed(x,y,button)
	if _G[state.."_keypressed"] then
		_G[state.."_keypressed"](x,y,button)
	end
	mousestate = button
end
function love.mousereleased()
	mousestate = "nothing"
end
function playsound(source)
	love.audio.stop(source);love.audio.rewind(source);love.audio.play(source)
end